import java.util.*;
import java.io.*;
public class StockMarket 
{
	
	ArrayList<Order> pending_list;
	public static void main(String[] args) throws Exception
	{
		int count=1;
		BufferedReader buf = new BufferedReader(new InputStreamReader(System.in));
		StockMarket stock_market = new StockMarket();
		stock_market.pending_list = new ArrayList<Order>();
		while(true)
		{
			System.out.println("Press 1 to Add an Order");
			System.out.println("Press 2 to View the pending list");
			System.out.println("Press 3 to Exit");
			
			String s=buf.readLine();
			if(s.equals("1"))
			{
				System.out.println("Enter your Customer ID");
				int cid=Integer.parseInt(buf.readLine());
				System.out.println("Enter the Stock Name");
				String sname=(buf.readLine());
				sname=sname.toLowerCase();
				System.out.println("Enter your Trade Type(Buy/Sell)");
				String type = buf.readLine();
				type= type.toLowerCase();
				while(!(type.equals("buy") || type.equals("sell")))
				{
					System.out.println("Please Enter Buy or Sell");
					type = buf.readLine();
					type= type.toLowerCase();
				}
				System.out.println("Enter your Price");
				int price = Integer.parseInt(buf.readLine());
				System.out.println("Enter your Quantity");
				int quant = Integer.parseInt(buf.readLine());
				
				boolean is_trade=stock_market.AddOrder(count,cid,sname,type,price,quant);
				if(is_trade)
						System.out.println("Trade Made\n");
				else
						System.out.println("Added to Pending List\n");
				count++;
			}
			else if(s.equals("2"))
			{
				System.out.println(stock_market.ViewList());
			}
			else
			{
				System.exit(0);
			}
		}
	}
	String ViewList()
	{
		if(pending_list.size() == 0)
		{
			System.out.println("List is empty\n");
			return "";
		}
		else
		{
			String ans="";
			for(int i=0;i<pending_list.size();i++)
			{
				
				//System.out.println(pending_list.get(i).toString());
				if(i == pending_list.size()-1)
					ans+=pending_list.get(i).toString();
				else
					ans+=pending_list.get(i).toString()+"\n";
				//System.out.println("");
			}
			return ans;

		}
	}
	boolean AddOrder(int count,int cid,String sname, String type,int price, int quant)
	{
		boolean trade=false;
		Order new_order= new Order(count,cid,sname,type,price,quant);
		boolean ans=MatchOrder(new_order);
		if(ans == true)
				trade=true;
		return trade;
	}
	boolean MatchOrder(Order new_order)
	{
		boolean did_match=false;
		if(new_order.getTradeType().toLowerCase().equals("buy"))
		{
			for(int i=0;i<pending_list.size();i++)
			{
				Order order = pending_list.get(i);
				if(order.getCustID() != new_order.getCustID() && order.getTradeType().toLowerCase().equals("sell") && new_order.getStockName().equals(order.getStockName()) &&order.getPrice() <= new_order.getPrice() )
				{
					if(order.getQuantity() > new_order.getQuantity())
					{
						order.setQuantity(order.getQuantity()-new_order.getQuantity());
						did_match=true;
						break;
					}
					else if(order.getQuantity() == new_order.getQuantity())
					{
						pending_list.remove(i);
						did_match=true;
						break;
					}
					else
					{
						pending_list.remove(i);
						new_order.setQuantity(new_order.getQuantity()-order.getQuantity());
						i--;
					}
				}
			}
		}
		else 
		{
			for(int i=0;i<pending_list.size();i++)
			{
				Order order = pending_list.get(i);
				if(order.getCustID() != new_order.getCustID() && order.getTradeType().toLowerCase().equals("buy")&& new_order.getStockName().equals(order.getStockName()) && order.getPrice() >= new_order.getPrice() )
				{
					if(order.getQuantity() > new_order.getQuantity())
					{
						order.setQuantity(order.getQuantity()-new_order.getQuantity());
						did_match=true;
						break;
					}
					else if(order.getQuantity() == new_order.getQuantity())
					{
						pending_list.remove(i);
						did_match=true;
						break;
					}
					else
					{
						pending_list.remove(i);
						new_order.setQuantity(new_order.getQuantity()-order.getQuantity());
						i--;
					}
				}
			}
		}
		if(did_match == false)
		{
			pending_list.add(new_order);
		}
		return did_match;
	}
}
class Order
{
	private int order_ts; // Timestamp
	private int cust_id; // Customer Id
	private String stock_name; //  Stock ID
	private String trade_type; // B for Buy, S for Sell
	private int price;// The price at which the trade should proceed
	private int quantity; // How many stocks to buy or sell
	public Order(int ts,int cid,String sid,String type,int cost,int quant)
	{
		this.order_ts=ts;
		this.cust_id=cid;
		this.stock_name=sid;
		this.trade_type=type;
		this.price=cost;
		this.quantity=quant;
		
		
	}
	
	public int getOrderTS()
	{
		return this.order_ts;
		
	}
	public int getCustID()
	{
		return this.cust_id;
		
	}
	public String getStockName()
	{
		return this.stock_name;
		
	}
	public String getTradeType()
	{
		return this.trade_type;
		
	}
	public int getPrice()
	{
		return this.price;
		
	}
	public int getQuantity()
	{
		return this.quantity;
		
	}
	public void setPrice(int nprice)
	{
		 this.price=nprice;
		
	}
	public void setQuantity(int nquantity)
	{
		this.quantity=nquantity;
		
	}
	
	public String toString()
	{
		String str="";
		str=order_ts+","+cust_id+","+stock_name+","+trade_type+","+price+","+quantity;
		return str;
	}
	
	
	
}

